## mythtv 34.0+fixes.20241130.83f01662

=== debian/changelog ===
mythtv (2:34.0+fixes.20241130.83f01662-0ubuntu0) bookworm; urgency=medium

  * Scripted Build from fixes git packaging [83f01662]
  * New upstream checkout (83f01662)

 -- andy <andy@thor>  Sat, 30 Nov 2024 20:59:00 -0500

mythtv (2:34.0+fixes) mantic; urgency=medium

  * Dummy entry to bump version to fixes/34

 -- Roland Ernst <rcrernst@gmail.com>  Tue, 13 Feb 2024 21:15:49 +0100
