=== debian/changelog ===
mythtv (2:35.0+fixes.20250302.f3f012aa3f-0ubuntu6) resolute; urgency=medium

  * Rebuild against latest libbluray

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 19 Oct 2025 13:51:14 -0400

mythtv (2:35.0+fixes.20250302.f3f012aa3f-0ubuntu5) resolute; urgency=medium

  * Rebuild against new libx264-165.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 18 Oct 2025 19:45:09 +0200

mythtv (2:35.0+fixes.20250302.f3f012aa3f-0ubuntu4) questing; urgency=medium

  * No-change rebuild for libxml2 soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 22 May 2025 12:18:34 +0200

mythtv (2:35.0+fixes.20250302.f3f012aa3f-0ubuntu3) plucky; urgency=medium

  * No-change rebuild for flac.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 14 Mar 2025 22:38:21 -0500

mythtv (2:35.0+fixes.20250302.f3f012aa3f-0ubuntu2) plucky; urgency=medium

  * Disable QtWebKit5 support and the Browser plugin (LP: #2100639).

 -- Simon Quigley <tsimonq2@ubuntu.com>  Wed, 05 Mar 2025 00:02:23 -0600

mythtv (2:35.0+fixes.20250302.f3f012aa3f-0ubuntu1) plucky; urgency=medium

  * Scripted Build from fixes git packaging [ae1210e8]
  * New upstream checkout (f3f012aa3f)

 -- Mario Limonciello <superm1@gmail.com>  Sun, 02 Mar 2025 21:27:28 -0600

mythtv (2:35.0+fixes) noble; urgency=medium

  * Dummy entry to bump version to fixes/35

 -- Roland Ernst <rcrernst@gmail.com>  Thu, 13 Feb 2025 20:15:49 +0100

mythtv (2:35.0~master) noble; urgency=medium

  * Switch desktop to use the Web App rather than mythtv-setup

 -- Bill Meek <bmeek@mythtv.org>  Mon, 27 Jan 2025 19:01:23 -0600

mythtv (2:35.0~master) mantic; urgency=medium

  * Dummy entry to bump version to 35

 -- Roland Ernst <rcrernst@gmail.com>  Tue, 13 Feb 2024 21:15:49 +0100
